#include "stdafx.h"

#include "DiskMark.h"
#include "DiskMarkDlg.h"
#include "DiskBench.h"

#include <winioctl.h>
#include <mmsystem.h>
#pragma comment(lib,"winmm.lib")


#define DISK_TEST_MAX_SIZE         (100*1024*1024)
#define DISK_TEST_MAX_BUFFER_SIZE  1024*1024
#define DISK_TEST_TIME             6*1000
#define DISK_TEST_TRY_NUMBER       5

static char* buf = NULL;
static CString TestFilePath;
static CString TestFileDir;

void ExecDiskBench(void* dlg)
{
	BOOL FlagArc;
	static CString cstr;
	char drive;
	int count;
	double score, max_score;
	
	drive = ((CDiskMarkDlg*)dlg)->m_DriveValue.GetAt(0);
	((CDiskMarkDlg*)dlg)->m_DiskBenchStatus = TRUE;

// hCük擾
	char RootPath[4];
	wsprintf(RootPath, "%c:\\", drive);

	TestFileDir.Format("%sCrystalDiskMark%08X", RootPath, timeGetTime());
	CreateDirectory(TestFileDir, NULL);
	TestFilePath.Format("%s\\CrystalDiskMark%08X.tmp", TestFileDir, timeGetTime());

	DWORD FileSystemFlags;
	GetVolumeInformation(RootPath,NULL,NULL,NULL,NULL,&FileSystemFlags,NULL,NULL);
	if( FileSystemFlags & FS_VOL_IS_COMPRESSED ){
		FlagArc = TRUE;
	}else{
		FlagArc = FALSE;
	}

// hCű󂫗eʂmF //
	OSVERSIONINFO osVersionInfo;
	osVersionInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&osVersionInfo);

	ULARGE_INTEGER FreeBytesAvailableToCaller,TotalNumberOfBytes,TotalNumberOfFreeBytes;
	GetDiskFreeSpaceEx(RootPath,&FreeBytesAvailableToCaller,&TotalNumberOfBytes,&TotalNumberOfFreeBytes);
	if(TotalNumberOfFreeBytes.HighPart == 0 && DISK_TEST_MAX_SIZE > TotalNumberOfFreeBytes.LowPart )
	{
		AfxMessageBox("Disk capacity is insufficient.");
		return ExitDiskBench(dlg);
	}

// ݉\`FbN
	DWORD writesize;
	char data[] = "123";
	HANDLE hFile = ::CreateFile(TestFilePath, GENERIC_READ|GENERIC_WRITE, 0, NULL,
								CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == NULL){
		AfxMessageBox("Failed CreateFile()!!");
		return ExitDiskBench(dlg);
	}

	WriteFile(hFile, data, 4, &writesize, NULL);
	cstr.Format("%d", writesize);
	CloseHandle(hFile);
	DeleteFile(TestFilePath);

	if(writesize == 0){
		AfxMessageBox("Write Error!!");
		return ExitDiskBench(dlg);
	}

// t@Cp
	DWORD BufSize = DISK_TEST_MAX_BUFFER_SIZE;
	DWORD Loop = DISK_TEST_MAX_SIZE / BufSize;
	DWORD i, j;

	buf = (char*)VirtualAlloc(NULL, BufSize, MEM_COMMIT, PAGE_READWRITE);
	if(buf == NULL){
		AfxMessageBox("Failed VirtualAlloc()");
		return ExitDiskBench(dlg);
	}

	if(FlagArc != FALSE){ // khCȕꍇ
		DWORD temp = BufSize / 2;
		for(i=0;i<temp;i++){
			memset((USHORT*)buf[i*2], rand(), 2);
		}
	}

	DWORD start, finish;

//////////////////////////////////////////////
// eXgt@C̐
//////////////////////////////////////////////

	cstr = "Preparing...";
	::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_MESSAGE, (WPARAM)&cstr, 0);


	hFile = ::CreateFile(TestFilePath, GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
			FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_SEQUENTIAL_SCAN, NULL);

// k //
	USHORT lpInBuffer = COMPRESSION_FORMAT_NONE;
	DWORD lpBytesReturned = 0;
	DeviceIoControl(hFile, FSCTL_SET_COMPRESSION, (LPVOID) &lpInBuffer,
				sizeof(USHORT), NULL, 0, (LPDWORD)&lpBytesReturned, NULL);

	start = timeGetTime();
	for(i = 0;i < Loop;i++){
		if(((CDiskMarkDlg*)dlg)->m_DiskBenchStatus){
			WriteFile(hFile, buf, BufSize, &writesize, NULL);
		}else{
			CloseHandle(hFile);
			return ExitDiskBench(dlg);
		}
	}
	CloseHandle(hFile);
	finish = timeGetTime();
/*
	cstr.Format("%.1f MB/s", 1024.0 / (finish - start) * 1000);
	AfxMessageBox(cstr);
*/
//////////////////////////////////////////////
// ǂݍ݃eXg 
//////////////////////////////////////////////
	if(! ((CDiskMarkDlg*)dlg)->m_DiskBenchStatus){
		return ExitDiskBench(dlg);
	}

	score = 0.0;
	max_score = 0.0;
	for(j = 1; j <= DISK_TEST_TRY_NUMBER; j++){
		cstr.Format("Sequential Read %d/%d", j, DISK_TEST_TRY_NUMBER);
		::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_MESSAGE, (WPARAM)&cstr, 0);

		hFile = ::CreateFile(TestFilePath, GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_SEQUENTIAL_SCAN, NULL);

		count = 0;
		start = timeGetTime();
		do{
			for(i = 0; i < Loop; i++){
				ReadFile(hFile, buf, BufSize, &writesize, NULL);
				count++;
			}
			SetFilePointer(hFile, 0, NULL, FILE_BEGIN);
		}while((start + DISK_TEST_TIME) > timeGetTime());

		CloseHandle(hFile);
		finish = timeGetTime();
		score = ((double)count * BufSize) / (finish - start) / 1000;
		if(score > max_score){
			max_score = score;
		}
		((CDiskMarkDlg*)dlg)->m_SequentialReadScore = score;
		::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_SCORE, 0, 0);
		if(! ((CDiskMarkDlg*)dlg)->m_DiskBenchStatus){
			return ExitDiskBench(dlg);
		}
	}
	((CDiskMarkDlg*)dlg)->m_SequentialReadScore = max_score;
	::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_SCORE, 0, 0);

//////////////////////////////////////////////
// ݃eXg 
//////////////////////////////////////////////
	if(! ((CDiskMarkDlg*)dlg)->m_DiskBenchStatus){
		return ExitDiskBench(dlg);
	}
	score = 0.0;
	max_score = 0.0;
	for(j = 1; j <= DISK_TEST_TRY_NUMBER; j++){
		cstr.Format("Sequential Write %d/%d", j, DISK_TEST_TRY_NUMBER);
		::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_MESSAGE, (WPARAM)&cstr, 0);
		hFile = ::CreateFile(TestFilePath, GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
				FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_SEQUENTIAL_SCAN, NULL);

		count = 0;
		start = timeGetTime();
		do{
			for(i = 0; i < Loop; i++){
				WriteFile(hFile, buf, BufSize, &writesize, NULL);
				count++;
			}
			SetFilePointer(hFile, 0, NULL, FILE_BEGIN);
		}while((start + DISK_TEST_TIME) > timeGetTime());
		FlushFileBuffers(hFile);
		CloseHandle(hFile);

		finish = timeGetTime();
		score = ((double)count * BufSize) / (finish - start) / 1000;
		if(score > max_score){
			max_score = score;
		}
		((CDiskMarkDlg*)dlg)->m_SequentialWriteScore = score;
		::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_SCORE, 0, 0);
		if(! ((CDiskMarkDlg*)dlg)->m_DiskBenchStatus){
			return ExitDiskBench(dlg);
		}
	}
	((CDiskMarkDlg*)dlg)->m_SequentialWriteScore = max_score;
	::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_SCORE, 0, 0);

//////////////////////////////////////////////
// ǂݍ݃eXg 512KB
//////////////////////////////////////////////
/*
	if(! ((CDiskMarkDlg*)dlg)->m_DiskBenchStatus){
		return ExitDiskBench(dlg);
	}

	score = 0.0;
	max_score = 0.0;
	BufSize = 512 * 1024;
	Loop = DISK_TEST_MAX_SIZE / BufSize;

	for(j = 1; j <= DISK_TEST_TRY_NUMBER; j++){
		cstr.Format("RandRD512 %d/%d", j, DISK_TEST_TRY_NUMBER);
		::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_MESSAGE, (WPARAM)&cstr, 0);

		hFile = ::CreateFile(TestFilePath, GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_RANDOM_ACCESS, NULL);

		count = 0;
		start = timeGetTime();
		do{
			for(i = 0; i < Loop; i++){
				SetFilePointer(hFile, (rand() % Loop) * BufSize, NULL, FILE_BEGIN);
				ReadFile(hFile, buf, BufSize, &writesize, NULL);
				count++;
			}
		}while((start + DISK_TEST_TIME) > timeGetTime());

		CloseHandle(hFile);
		finish = timeGetTime();
		score = ((double)count * BufSize) / (finish - start) / 1000;
		if(score > max_score){
			max_score = score;
		}
		((CDiskMarkDlg*)dlg)->m_RandomRead512KBScore = score;
		::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_SCORE, 0, 0);
		if(! ((CDiskMarkDlg*)dlg)->m_DiskBenchStatus){
			return ExitDiskBench(dlg);
		}
	}
	((CDiskMarkDlg*)dlg)->m_RandomRead512KBScore = max_score;
	::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_SCORE, 0, 0);

//////////////////////////////////////////////
// ݃eXg 512KB
//////////////////////////////////////////////
/	if(! ((CDiskMarkDlg*)dlg)->m_DiskBenchStatus){
		return ExitDiskBench(dlg);
	}
	score = 0.0;
	max_score = 0.0;
	for(j = 1; j <= DISK_TEST_TRY_NUMBER; j++){
		cstr.Format("RandWR512 %d/%d", j, DISK_TEST_TRY_NUMBER);
		::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_MESSAGE, (WPARAM)&cstr, 0);
		hFile = ::CreateFile(TestFilePath, GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
				FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_RANDOM_ACCESS, NULL);

		count = 0;
		start = timeGetTime();
		do{
			for(i = 0; i < Loop; i++){
				SetFilePointer(hFile, (rand() % Loop) * BufSize, NULL, FILE_BEGIN);
				WriteFile(hFile, buf, BufSize, &writesize, NULL);
				count++;
			}
		}while((start + DISK_TEST_TIME) > timeGetTime());
		FlushFileBuffers(hFile);
		CloseHandle(hFile);
		finish = timeGetTime();
		score = ((double)count * BufSize) / (finish - start) / 1000;
		if(score > max_score){
			max_score = score;
		}
		((CDiskMarkDlg*)dlg)->m_RandomWrite512KBScore = score;
		::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_SCORE, 0, 0);
		if(! ((CDiskMarkDlg*)dlg)->m_DiskBenchStatus){
			return ExitDiskBench(dlg);
		}
	}

	((CDiskMarkDlg*)dlg)->m_RandomWrite512KBScore = max_score;
	::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_SCORE, 0, 0);
*/

	ExitDiskBench(dlg);
}

void ExitDiskBench(void* dlg)
{
	if(buf != NULL){
		VirtualFree(buf, DISK_TEST_MAX_BUFFER_SIZE, MEM_DECOMMIT);
	}
	DeleteFile(TestFilePath);
	RemoveDirectory(TestFileDir);

	((CDiskMarkDlg*)dlg)->m_hThread = NULL;
	((CDiskMarkDlg*)dlg)->m_DiskBenchStatus = FALSE;

	static CString cstr;
	cstr = "";
	::PostMessage(((CDiskMarkDlg*)dlg)->GetSafeHwnd(), WM_USER_UPDATE_MESSAGE, (WPARAM)&cstr, 0);
}
